(function ($, Drupal) {
  Drupal.behaviors.addParamToAjax = {
    attach: function (context, settings) {
      // Use jQuery's ajaxSend() to intercept every AJAX request.
      $(document).ajaxSend(function (event, jqxhr, ajaxSettings) {
        // Only modify if there’s a URL present (i.e., it's a real request).
        if (ajaxSettings.url) {
          // Append your custom GET parameter.
          var url = new URL(ajaxSettings.url, window.location.origin);
          if (settings.siteId && settings.sitesCsrf) {
            url.searchParams.set('site_id', settings.siteId);
            url.searchParams.set('sites_csrf', settings.sitesCsrf);
          }
          ajaxSettings.url = url.toString();
        }
      });
    },
  };
})(jQuery, Drupal);
