<?php

declare(strict_types=1);

namespace Drupal\sites_group_overrides\EventSubscriber;

use Drupal\sites_group_overrides\Event\FieldOverrideEvent;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

/**
 * @todo Add description for this subscriber.
 */
final class FieldOverride implements EventSubscriberInterface {

  /**
   * {@inheritdoc}
   */
  public function onFieldOverride(FieldOverrideEvent $event) {
    $entity = $event->getEntity();
    $entity_field_name = $event->getFieldName();
    $value = $entity->get($entity_field_name)->getValue();
    $event->setValue($value);
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents(): array {
    return [
      FieldOverrideEvent::EVENT_NAME => ['onFieldOverride', 100],
    ];
  }

}
